import '../../domain/domain.dart';

class SignupPayloadBasicModel implements AuthSignUpPayload {
  final String email;
  final String password;
  final String? username;
  final String? firstName;
  final String? lastName;

  @override
  final AuthDeviceInfo? deviceInfo;

  SignupPayloadBasicModel({
    required this.email,
    required this.password,
    this.username,
    this.firstName,
    this.lastName,
    this.deviceInfo,
  });

  @override
  Map<String, dynamic> toMap() {
    Map<String, dynamic> base = {
      "email": email,
      "password": password,
    };

    if (username != null) {
      base.addAll({
        "username": username,
      });
    }
    if (firstName != null) {
      base.addAll({
        "firstName": firstName,
      });
    }
    if (lastName != null) {
      base.addAll({
        "lastName": lastName,
      });
    }
    if (deviceInfo != null) {
      base.addAll({
        "deviceInfo": deviceInfo,
      });
    }
    return base;
  }

  @override
  SignupPayloadBasicModel copyWith({
    String? email,
    String? password,
    String? username,
    String? firstName,
    String? lastName,
    AuthDeviceInfo? deviceInfo,
  }) {
    return SignupPayloadBasicModel(
      email: email ?? this.email,
      password: password ?? this.password,
      username: username ?? this.username,
      firstName: firstName ?? this.firstName,
      lastName: lastName ?? this.lastName,
      deviceInfo: deviceInfo ?? this.deviceInfo,
    );
  }
}
